﻿@page
@model IndexModel
@{
    ViewData["Title"] = "Home page";
}

@*<link href="https://unpkg.com/bootstrap-table@1.15.4/dist/bootstrap-table.min.css" rel="stylesheet">*@

<div class="row">
    <div class="col-md-6 section-top-addUser">
        <button type="button" class="btn btn-outline-primary btnAdd">Add New</button>
    </div>
</div>

<div class="row">
    <div class="col-md-12">
        <form action="" method="get">
            <table class="table table-sm table-hover" id="tblArtists">
                <thead>
                    <tr>
                        <th data-formatter="NumberFormatter">No.</th>
                        <th data-field="ArtistID" data-visible="false">ID</th>
                        <th data-field="ImageURL" data-sortable="true" data-formatter="ImgFormatter">Album Name</th>
                        <th data-field="ArtistName" data-sortable="true">Artist Name</th>
                        <th data-field="AlbumName" data-visible="false">Album Name</th>
                        <th data-field="ReleaseDate" data-sortable="true" data-formatter="dateFormat">Release Date</th>
                        <th data-field="SampleURL" data-formatter="MusicFormatter" data-events="PlayEvents">Sample Audio</th>
                        <th data-field="Price" data-sortable="true">Price</th>
                        <th data-field="Action" data-formatter="ActionFormatter" data-events="ActionEvents">Action</th>
                    </tr>
                </thead>
            </table>
        </form>
    </div>
</div>


<div class="modal fade" id="exampleModalCenter1" tabindex="-1" role="dialog" aria-labelledby="exampleModalCenterTitle" aria-hidden="true">
    <div class="modal-dialog modal-dialog-centered" role="document">
        <div class="modal-content add-usr-pop">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
                Artist Name : <span id="spArtistName"></span>
                <br />
                Album Name : <span id="spAlbumName"></span>
                <br />
                <img id="imgAlbum" style="width:100%"/>
                <div id="audioBody"></div>
            </div>
        </div>
    </div>
</div>

<div class="modal fade" id="addModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalCenterTitle" aria-hidden="true">
    <div class="modal-dialog modal-dialog-centered" role="document">
        <div class="modal-content add-usr-pop">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
                <form id="addForm" method="POST" action="https://localhost:44330/api/values" role="form">
                    <fieldset>
                        <input type="hidden" id="ArtistID" name="ArtistID" />
                        <div class="form-group row">
                            <label for="ArtistName" class="col-sm-4">Artist Name</label>
                            <div class="col-sm-8">
                                <input class="form-control" id="ArtistName" name="ArtistName" type="text" required>
                            </div>
                        </div>

                        <div class="form-group row">
                            <label for="AlbumName" class="col-sm-4">Album Name</label>
                            <div class="col-sm-8">
                                <input class="form-control" id="AlbumName" name="AlbumName" type="text" required>
                            </div>
                        </div>

                        <div class="form-group row">
                            <label for="Price" class="col-sm-4">Price</label>
                            <div class="col-sm-8">
                                <input class="form-control" id="Price" name="Price" type="number" min="0" value="0.00" step="0.01" required>
                            </div>
                        </div>

                        <div class="form-group row">
                            <label for="ReleaseDate" class="col-sm-4">Release Date</label>
                            <div class="col-sm-8" style="position: relative; padding-right:30px;">
                                <input type="text" class="form-control datepicker" id="ReleaseDate" name="ReleaseDate" required><i class="fa fa-calendar fa-2x" aria-hidden="true" style="position: absolute; right: 1.5em; top: 2px;"></i>
                            </div>
                        </div>

                        <div class="form-group row">
                            <label for="ImageURL" class="col-sm-4">Image URL</label>
                            <div class="col-sm-8">
                                <textarea class="form-control" id="ImageURL" name="ImageURL" rows="3"></textarea>
                            </div>
                        </div>

                        <div class="form-group row">
                            <label for="SampleURL" class="col-sm-4">Sample URL</label>
                            <div class="col-sm-8">
                                <textarea class="form-control" id="SampleURL" name="SampleURL" rows="3"></textarea>
                            </div>
                        </div>

                        <hr />

                        <p>
                            <button class="btn btn-outline-primary" type="submit">Save</button>
                        </p>
                    </fieldset>
                </form>
            </div>
        </div>
    </div>
</div>

<div id="divAudio" style="display:none;">
    <audio controls autoplay>
        <source class="srcMP3" type="audio/mpeg">
        Your browser does not support the audio element.
    </audio>
</div>

<script type="text/javascript">

    $('#ReleaseDate').on('click', function () {
        $('.datepicker').pickadate({
            selectMonths: true,
            selectYears: true,
            close: ''
        }).pickadate('picker').start();
        $('.datepicker').addClass('picker__input--active');
    });

    $('#ReleaseDate').on('change', function () {
        $('.datepicker').pickadate().pickadate('picker').stop();
    });

    $(document).ready(function () {
        $('#cover-load').show();
        bindArtists();
    });

    function bindArtists() {
        $.ajax({
            url: "https://localhost:44330/api/values",
            type: 'GET',
            dataType: 'json',
            success: function (p) {
                $('#tblArtists').bootstrapTable("destroy").bootstrapTable({
                    data: p,
                    pagination: true,
                    //pageNumber
                    //count
                    sortable: true,
                    pageSize: 10,
                    pageList: [10, 25, 50, 75]
                });
                $('#cover-load').hide();
            }
        });
    }

    function NumberFormatter(value, row, index) {
        return index + 1 + '.';
    }

    function ImgFormatter(value, row, index) {
        return '<div class="row"><img class="col-md-6 image-url" src="' + value + '" /><p class="col-md-6">' + row.AlbumName + '</p>';
    }

    function MusicFormatter(value, row, index) {
        return '<button type="button" class="btnPlay"></button>';
    }

    function dateFormat(value, row, index) {
        if (value != null)
            return moment(value).format('DD MMM YYYY');
        else
            return '-';
    }

    function ActionFormatter(value, row, index) {
        return '<button type="button" class="btn btn-outline-success btnEdit">Edit</button>' +
            '<button type="button" class="btn btn-outline-danger btnDelete">Delete</button>';
    }

    window.PlayEvents = {
        'click .btnPlay': function (e, value, row, index) {
            $('#exampleModalCenter1').modal('toggle');
            $('.srcMP3').attr("src", value);

            $('#audioBody').html($('#divAudio').html());
            $('#spArtistName').text(row.ArtistName);
            $('#spAlbumName').text(row.AlbumName);
            $('#imgAlbum').attr("src", row.ImageURL);
        }
    }

    $('#exampleModalCenter1').on('hidden.bs.modal', function () {
        $('audio').each(function () {
            this.pause(); // Stop playing
            this.currentTime = 0; // Reset time
        }); 
    });

    $(".btnAdd").click(function (e) {
        e.stopPropagation();
        $('#addModal').modal('toggle');
        resetForm();
    });

    function resetForm() {
        $('#ArtistID').val(0);
        $('#ArtistName').val('');
        $('#AlbumName').val('');
        $('#Price').val('');
        $('#ImageURL').val('');
        $('#SampleURL').val('');
        $('.datepicker').pickadate().pickadate('picker').close();
        $('.datepicker').pickadate('set').set('select', null);
    }

    window.ActionEvents = {
        'click .btnEdit': function (e, value, row, index) {
            $('#addModal').modal('toggle');
            $('#ArtistID').val(row.ArtistID);
            $('#ArtistName').val(row.ArtistName);
            $('#AlbumName').val(row.AlbumName);
            $('#Price').val(row.Price);
            $('#ImageURL').val(row.ImageURL);
            $('#SampleURL').val(row.SampleURL);

            var rd = moment(row.ReleaseDate).format('YYYY/MM/DD');
            $('.datepicker').pickadate({
                selectMonths: true,
                selectYears: true
            }).pickadate('picker').close();
            $('.datepicker').pickadate('set').set('select', new Date(rd));
        },
        'click .btnDelete': function (e, value, row, index) {
            $('#cover-load').show();
            if (confirm("Are you sure want to delete this row?")) {
                $.ajax({
                    url: "https://localhost:44330/api/values/" + row.ArtistID,
                    type: 'DELETE',
                    dataType: 'json',                // <---update this
                    success: function (p) {
                        alert('Delete Success');
                        bindArtists();
                    },
                    error: function (e) {
                        alert("Error");
                        console.log(e);
                        $('#cover-load').hide();
                    }
                });
            }
            else {
                $('#cover-load').hide();
            }
        },
    }


    $('#addForm').ajaxForm({
        dataType: 'json',
        data: $('#addForm').serialize(),
        beforeSubmit: function () {
            $('#cover-load').show();
        },
        success: function (p) {
            $('#addModal').modal('toggle');
            $("#addForm")[0].reset();
            bindArtists();
            alert("Success");
            resetForm();
            $('#cover-load').hide();
        },
        error: function (e) {
            alert("Error");
            console.log(e);
            $('#cover-load').hide();
        }
    });
</script>
